'option explicit

#include once "source\gui.bi"

Dim Shared As TForm Form
Dim Shared As TComboBox Combo
Dim Shared As TPanel Panel

Declare Sub ComboDrawItem(Self As TComboBox,byval ItemIndex As Integer,byval State As Integer, R As Rect)     
Declare Sub ComboMeasureItem(Self As TComboBox,byval ItemIndex As Integer,byref Height As Integer)

redim shared Bmps(5) as HBITMAP
Bmps(0) = LoadImage(0,"newxp.bmp",IMAGE_BITMAP,0,0,LR_LOADMAP3DCOLORS OR LR_LOADFROMFILE OR LR_LOADTRANSPARENT)  
Bmps(1) = LoadImage(0,"openxp.bmp",IMAGE_BITMAP,0,0,LR_LOADMAP3DCOLORS OR LR_LOADFROMFILE OR LR_LOADTRANSPARENT)  
Bmps(2) = LoadImage(0,"savexp.bmp",IMAGE_BITMAP,0,0,LR_LOADMAP3DCOLORS OR LR_LOADFROMFILE OR LR_LOADTRANSPARENT)  
Bmps(3) = LoadImage(0,"printxp.bmp",IMAGE_BITMAP,0,0,LR_LOADMAP3DCOLORS OR LR_LOADFROMFILE OR LR_LOADTRANSPARENT)  
Bmps(4) = LoadImage(0,"exitxp.bmp",IMAGE_BITMAP,0,0,LR_LOADMAP3DCOLORS OR LR_LOADFROMFILE OR LR_LOADTRANSPARENT)

With Form
     .Caption     = "Test ComboBox"
     .Width       = 180
     .Height      = 100
     .Position    = poCenterScreen
     .BorderStyle = fbdialog
     TForm_Initialize(Form)
End With

With Panel
     .Parent     = Form.Handle
     .Color      = &HFF00FF
     .Font.Color = &H0000FF
     .Font.Name  = "Lucida Console"
     .Font.Size  = 10
     .Left       = 10
     .Top        = 10
     .Caption    = "Panel"
     .bevelin = bvlowered
     .bevelout = bvlowered
     TPanel_Initialize(Panel)
End With

With Combo
     .Parent        = Panel.Handle
     .Font.Name     = "Lucida Console"
     .Font.Size     = 10
     .Left          = (Panel.Width  - 121)/2 
     .Top           = 10
     .Style         = csOwnerDrawVariable
     .ondrawitem    = @Combodrawitem
     .onmeasureitem = @Combomeasureitem
     TComboBox_Initialize(Combo)
     Combo.AddItem(Combo,"Item 1")
     Combo.AddItem(Combo,"Item 2")
     Combo.AddItem(Combo,"Item 3")
     Combo.AddItem(Combo,"Item 4")
     Combo.AddItem(Combo,"Item 5")
End With

Form.Show(Form)
Application.Run(Application)

Sub ComboDrawItem(Self As TComboBox,byval ItemIndex As Integer,byval State As Integer, R As Rect)     
    Dim As String s
    If State and ODS_SELECTED then
        Self.Canvas.Pen.Color = &HFFFF
        Self.Canvas.Brush.Color = &H00FFFF
        Self.Canvas.Rectangle(Self.Canvas,R.Left,R.Top,R.Right,R.Bottom)
    Else 
        Self.Canvas.Pen.Color = Self.Color
        Self.Canvas.Brush.Color = Self.Color
        Self.Canvas.Rectangle(Self.Canvas,R.Left,R.Top,R.Right,R.Bottom)
    End If 
    s = Space(SendMessage(Self.Handle,CB_GETLBTEXTLEN,ItemIndex,0) + 1)
    SendMessage(Self.Handle,CB_GETLBTEXT,ItemIndex,cint(StrPtr(s)))
    Self.Canvas.TextOut(Self.Canvas,32,R.Top + 2,s,Self.Font.Color,-1)
    DrawState(Self.Canvas.DC,0,0,cint(Bmps(ItemIndex)),0,4,R.Top +1,16,16,DST_BITMAP or DSS_NORMAL)  
End Sub

Sub ComboMeasureItem(Self As TComboBox,byval ItemIndex As Integer,byref Height As Integer)
   select case itemindex
          case 0 :Height = 21
          case 1 :Height = 44
          case 2 :Height = 32
          case else : Height = 18
   end select
End Sub