'--------------------------------------------------------------------
'           BMP2HTML CONVERTER v1.0.2
'                  by Nastase Eodor
'       THIS PROGRAM CONVERTS A BMP PIC (24BITS) INTO A HTML FILE
'--------------------------------------------------------------------
'option explicit

#include once "windows.bi"

dim memDC     as HDC 
dim Picture   as HBITMAP
dim Bi        as BITMAP
dim F         as integer
dim FileName  as string

dim x         as integer
dim y         as integer
dim Tmp_Str   as string
dim PixColor  as integer
dim FileHtml  as string

dim Red       as string
dim Green     as string
dim Blue      as string
dim StrColor  as string

'--------------------------------------------------------------------
FileName      = Command(1)
if FileName   = "" then
    Print "           BMP2HTML v1.0.2  by Nastase Eodor"
    Print " usage : BMP2HTML <pic.bmp> "
    Print " This program converts a bmp picture into a html"
    Print " use small pic`s like <= 320x200 (not 1024x768) , html will be BIG)"
    Print " the <pic.bmp> will be saved as <pic.html>"
    do:Loop
 else    
    FileHtml=mid(command(1),1,len(command(1))-4)
    FileHtml=FileHtml+".html"
 end if
'--------------------------------------------------------------------
Picture  = LoadImage(0,FileName,IMAGE_BITMAP,0,0,LR_LOADFROMFILE OR LR_LOADTRANSPARENT OR LR_LOADMAP3DCOLORS)
GetObject(Picture,SizeOf(BITMAP),@Bi)
memDC = CreateCompatibleDC(0)
SelectObject(memDC,Picture)
'--------------------------------------------------------------------
F = FreeFile
Open FileHtml For Binary As #F
Print #F, "<!-- ***************************************** -->"
Print #F, "<!-- *          MADE WITH BMP2HTML           * -->"
Print #F, "<!-- ***************************************** -->"
Print #F, "<div align=center>"
Print #F, "<table border="+"0"+" cellspacing="+"0"+" cellpadding="+"0"+" >"
'--------------------------------------------------------------------
for y=0 to Bi.bmheight
    Print #F,"<tr height="+chr(34)+"1"+chr(34)+ ">"
         for x=0 to  Bi.bmwidth
            PixColor=GetPixel(memDC,x,y)
            Tmp_Str=hex(PixColor)
            Red =mid(Tmp_Str,5,2)
            Green=mid(Tmp_Str,3,2)
            Blue=mid(Tmp_Str,1,2)
            StrColor="#" + Red + Green + Blue
            Print #F,"<td bgcolor=" + StrColor + " width="+chr(34)+"1"+chr(34)+"></td>"
         next x
         Print #F,"</tr>"
next y
DeleteObject(memDC)
Print "Ok . Done ."
'-------------------------------------------------------------------
Print #F, "  </table>"
Print #F, "</div>"

end
















