'Option Explicit

#Define WIN_INCLUDE_ALL
#include once "source\GUI.bi"
#include "vbcompat.bi"

Declare Sub StartClick(Sender As TButton)
Declare Sub StopClick(Sender As TButton)
Declare Sub crTimerTimer(Sender As TTimer)

Dim Shared As TForm Form
Dim Shared As TCheckBox Check,cxClear
Dim Shared As TLabel Label
Dim Shared As TButton bStart,bStop
Dim Shared As TTimer crTimer

crTimer.OnTimer = @crTimerTimer
TTimer_Initialize(crTimer)

Dim Shared dwTenths As Integer
Dim Shared dwSeconds As Integer
Dim Shared dwMinutes As Integer
Dim Shared dwHours As Integer

Form.Caption  = "Crono"
Form.Height   = 100
Form.Width    = 340
Form.Position = poCenterScreen
Form.BorderStyle = fbDialog
TForm_Initialize(Form)

Label.Parent    = Form.Handle
Label.Caption   = "00.00.00.0"
Label.Font.Size = 16
Label.Font.Name = "Lucida Console"
Label.Font.Style.fsBold = True 
Label.Font.Color = clLime
Label.Top       = 10
Label.Left      = 10
Label.Width     = Form.Canvas.TextWidth(Form.Canvas,Label.Caption)*4
Label.Height    = Form.Canvas.TextHeight(Form.Canvas,"Wg")+12
Label.BorderStyle = stSunken
Label.Alignment   = staCenter
TLabel_Initialize(Label)
Label.SetColor(Label,clBlack)

Check.Parent  = Form.Handle
Check.Caption = "Play sound"
Check.Left    = 10
Check.Top     = 40  
TCheckBox_Initialize(Check)

cxClear.Parent  = Form.Handle
cxClear.Caption = "Clear"
cxClear.Left    = Check.Left + Check.Width + 10
cxClear.Top     = 40  
TCheckBox_Initialize(cxClear)

bStart.Parent = Form.Handle
bStart.Caption = "Start"
bStart.Top     = 10
bStart.Left    = 250
bStart.OnClick = @StartClick
TButton_Initialize(bStart)

bStop.Parent = Form.Handle
bStop.Caption = "Stop"
bStop.Top     = 40
bStop.Left    = 250
bStop.OnClick = @StopClick
TButton_Initialize(bStop)

Form.Show(Form)
Application.Run(Application)

Sub StartClick(Sender As TButton)
    crTimer.Interval = 100
    crTimer.SetEnabled(crTimer,True)
    bStop.SetEnabled(bStop,True)
    bStart.SetEnabled(bStart,False)
    If cxClear.Checked then crTimer.Tag = 0
End Sub

Sub StopClick(Sender As TButton)
    crTimer.SetEnabled(crTimer,False)
    bStop.SetEnabled(bStop,False)
    bStart.SetEnabled(bStart,True)
End Sub

Sub crTimerTimer(Sender As TTimer)
    Dim As String Text
    Sender.Tag = Sender.Tag + 1'Sender.Interval
    dwTenths = Sender.Tag Mod 10
    dwSeconds = Sender.Tag / 10 Mod 60 
    dwMinutes = Sender.Tag / 1200 Mod 60 
    dwHours = Sender.Tag / 36000 Mod 60
    Text = Format(dwHours,"##00")+":"+ Format(dwMinutes,"##00")+":"+ Format(dwSeconds,"##00")+":"+Str(dwTenths)
    Label.SetCaption(Label,Text)
    If dwTenths = 0 Then
       If Check.Checked = True Then
          PlaySound("STOPWATCH", Instance, SND_RESOURCE OR SND_ASYNC)
       End If
    End If
End Sub




