'Option Explicit

#include once "source\gui.bi"

Declare Sub TabChange(Sender As TTabControl)
Declare Sub FormResize(Sender As TForm)

Dim shared Form As TForm
Dim shared Tabctrl As TTabcontrol

Form.Caption  = "Test TTabControl"
Form.OnResize = @FormResize 
TForm_initialize(form)

Tabctrl.Parent   = Form.Handle
Tabctrl.Width    = Form.ClientRect.Right
Tabctrl.Height   = Form.ClientRect.Bottom
Tabctrl.Hottrack = 1
Tabctrl.OnChange = @TabChange
TTabcontrol_Initialize(Tabctrl)

with Tabctrl
     .Images.AddBitmapMasked(.Images,LoadImage(0,"newxp.bmp",IMAGE_BITMAP,0,0,LR_LOADFROMFILE OR LR_LOADMAP3DCOLORS),&HFF00FF)
     .Images.AddBitmapMasked(.Images,LoadImage(0,"openxp.bmp",IMAGE_BITMAP,0,0,LR_LOADFROMFILE OR LR_LOADMAP3DCOLORS),&HFF00FF)
     .Images.AddBitmapMasked(.Images,LoadImage(0,"printxp.bmp",IMAGE_BITMAP,0,0,LR_LOADFROMFILE OR LR_LOADMAP3DCOLORS),&HFF00FF)
     .Images.AddBitmapMasked(.Images,LoadImage(0,"exitxp.bmp",IMAGE_BITMAP,0,0,LR_LOADFROMFILE OR LR_LOADMAP3DCOLORS),&HFF00FF)
end with

Tabctrl.AddTab(Tabctrl,"Tab 1")
Tabctrl.AddTab(Tabctrl,"Tab 2")
Tabctrl.AddTab(Tabctrl,"Tab 3")
Tabctrl.AddTab(Tabctrl,"Tab 4")

TabCtrl.SetTabIndex(Tabctrl,2)
TabChange(Tabctrl)

Form.Show(Form)

Application.Run(Application)

Sub FormResize(sender As TForm)
    Tabctrl.SetWidth(Tabctrl,Form.ClientRect.Right)
    Tabctrl.SetHeight(Tabctrl,Form.ClientRect.Bottom)
End Sub

Sub TabChange(Sender As TTabControl)
    Form.SetCaption(Form,"TestTabControl " + Str(Sender.TabIndex))
End Sub

