'Option Explicit

#include once "source\gui.bi"

Dim shared Form As TForm
Dim shared TreeView As TTreeView

Declare Sub FormResize(Sender As TForm)
Declare Sub TreeViewItemClick(Sender As TTreeView,byval Item As Integer)

Form.Caption  = "Test TTreeView"
Form.OnResize = @FormResize 
TForm_initialize(form)

TreeView.Parent   = Form.Handle
TreeView.Width    = Form.ClientRect.Right
TreeView.Height   = Form.ClientRect.Bottom
TreeView.OnItemClick = @TreeViewItemClick
TTreeView_Initialize(TreeView)

With TreeView
     .Images.AddBitmapMasked(.Images,LoadImage(0,"newxp.bmp",IMAGE_BITMAP,0,0,LR_LOADFROMFILE OR LR_LOADMAP3DCOLORS),&HFF00FF)
     .Images.AddBitmapMasked(.Images,LoadImage(0,"openxp.bmp",IMAGE_BITMAP,0,0,LR_LOADFROMFILE OR LR_LOADMAP3DCOLORS),&HFF00FF)
     .Images.AddBitmapMasked(.Images,LoadImage(0,"printxp.bmp",IMAGE_BITMAP,0,0,LR_LOADFROMFILE OR LR_LOADMAP3DCOLORS),&HFF00FF)
     .Images.AddBitmapMasked(.Images,LoadImage(0,"exitxp.bmp",IMAGE_BITMAP,0,0,LR_LOADFROMFILE OR LR_LOADMAP3DCOLORS),&HFF00FF)
     .Images.AddBitmapMasked(.Images,LoadImage(0,"copyxp.bmp",IMAGE_BITMAP,0,0,LR_LOADFROMFILE OR LR_LOADMAP3DCOLORS),&HFF00FF)
     .Images.AddBitmapMasked(.Images,LoadImage(0,"cutxp.bmp",IMAGE_BITMAP,0,0,LR_LOADFROMFILE OR LR_LOADMAP3DCOLORS),&HFF00FF)
     .Images.AddBitmapMasked(.Images,LoadImage(0,"pastexp.bmp",IMAGE_BITMAP,0,0,LR_LOADFROMFILE OR LR_LOADMAP3DCOLORS),&HFF00FF)
     .AddItem(TreeView,"Item1",1)
     .AddItem(TreeView,"Item2",1)
     .AddItem(TreeView,"Item3",1)
     .AddSubItem(TreeView,0,"SubItem1",0)
     .AddSubItem(TreeView,1,"SubItem2",2)
     .AddSubItem(TreeView,2,"SubItem3",3)
     .AddSubItem(TreeView,5,"Child1",4)
     .AddSubItem(TreeView,5,"Child2",5)
     .AddSubItem(TreeView,5,"Child3",6)
End With

Form.Show(Form)

Application.Run(Application)

Sub FormResize(sender As TForm)
    TreeView.SetWidth(TreeView,Form.ClientRect.Right)
    TreeView.SetHeight(TreeView,Form.ClientRect.Bottom)
    TreeView.FullExpand(TreeView)
End Sub

Sub TreeViewItemClick(Sender As TTreeView,byval Item As Integer)
    Form.SetCaption(Form,"Test TreeView " + Str(Item))
End Sub
